/*
  ---AVAILABLE FUNCTIONS---
  AS726X(TwoWire &wirePort = Wire, byte gain = 3, byte measurementMode = 3);
  void printMeasurements();
  byte getTemperature();
  float getTemperatureF();
  void setMeasurementMode(byte mode);
  boolean dataAvailable();
  void enableIndicator();
  void disableIndicator();
  void setIndicatorCurrent(byte current);
  void setBulbCurrent(byte current);
  void softReset();
  void setGain(byte gain);
  void setIntegrationTime(byte integrationValue);
  void enableInterrupt();
  void disableInterrupt();

*/
//2DO:
// obsługa przycisków zmieniających menu i LED
// obsługa przycisków zmieniających gain
//obsługa włączania/wyłączania LED

#include <SPI.h>
#include <Wire.h>
#include <Adafruit_GFX.h>
#include <Adafruit_SSD1306.h>
#include "AS726X.h"

AS726X sensor;
Adafruit_SSD1306 display(4);
  int RawRed = 0;
  int RawOrange = 0;
  int RawYellow = 0;
  int RawGreen = 0;
  int RawBlue = 0;
  int RawViolet = 0;
  float CalcRed  = 0.0;
  float CalcOrange = 0.0;
  float CalcYellow = 0.0;
  float CalcGreen = 0.0;
  float CalcBlue = 0.0;
  float CalcViolet = 0.0;
  int HeightRed = 0;
  int HeightOrange = 0;
  int HeightYellow = 0;
  int HeightGreen = 0;
  int HeightBlue = 0;
  int HeightViolet = 0;
  
  byte gain = 3; //  values: 0,1,2,3
  int menu_number = 3; //  values: 1,2,3 bez led, 4,5,6 z LED
  int LedPower = 0;
  int GraphHeight = 32;
//  int GrapStart = ;
  int GrapWidth = 20;
  float ReadValues[6] = {0, 0, 0, 0, 0, 0};
  float maxValue = 0.0;
  

void setup() {
  Wire.begin();
  Serial.begin(115200);
  display.begin(SSD1306_SWITCHCAPVCC, 0x3C);
  display.clearDisplay();
  sensor.begin();
}

void loop() {
  display.clearDisplay();
  display.setTextSize(1);
  display.setTextColor(WHITE);
  //data haverest  
  sensor.setGain(gain);
   if (menu_number > 3 ){
    LedPower = 1; 
   }

  if (LedPower == 1) {
   sensor.enableBulb();
   sensor.takeMeasurementsWithBulb(); 
  } else {
   sensor.disableBulb();
   sensor.takeMeasurements();
  }
  
  RawRed    = sensor.getRed();
  RawOrange = sensor.getOrange();
  RawYellow = sensor.getYellow();
  RawGreen  = sensor.getGreen();
  RawBlue   = sensor.getBlue();
  RawViolet = sensor.getViolet();

  CalcRed    = sensor.getCalibratedRed();
  CalcOrange = sensor.getCalibratedOrange();
  CalcYellow = sensor.getCalibratedYellow();
  CalcGreen  = sensor.getCalibratedGreen();
  CalcBlue   = sensor.getCalibratedBlue();
  CalcViolet = sensor.getCalibratedViolet();

  ReadValues[0] = CalcRed;
  ReadValues[1] = CalcOrange;
  ReadValues[2] = CalcYellow;
  ReadValues[3] = CalcGreen;
  ReadValues[4] = CalcBlue;
  ReadValues[5] = CalcViolet;
  
  

  if (menu_number == 1 || menu_number == 4  ) {//pokaż wartości przeliczone
    display.setCursor(0, 0);
    display.println("R:");
    display.setCursor(10, 0);
    display.println(CalcRed, 1);
    display.setCursor(0, 10);
    display.println("G:");
    display.setCursor(10, 10);
    display.println(CalcGreen, 1);
    display.setCursor(0, 20);
    display.println("B:");
    display.setCursor(10, 20);
    display.println(CalcBlue, 1);
    display.setCursor(60, 0);
    display.println("O:");
    display.setCursor(70, 0);
    display.println(CalcOrange, 1);
    display.setCursor(60, 10);
    display.println("Y:");
    display.setCursor(70, 10);
    display.println(CalcYellow, 1);
    display.setCursor(60, 20);
    display.println("V:");
    display.setCursor(70, 20);
    display.println(CalcViolet, 1);
    
  }
  if (menu_number == 2 || menu_number == 5) { //pokaż wartości bezpośrednie
    display.setCursor(0, 0);
    display.println("rR:");
    display.setCursor(10, 0);
    display.println(RawRed, 1);
    display.setCursor(0, 10);
    display.println("rG:");
    display.setCursor(10, 10);
    display.println(RawGreen, 1);
    display.setCursor(0, 20);
    display.println("rB:");
    display.setCursor(10, 20);
    display.println(RawBlue, 1);
    display.setCursor(60, 0);
    display.println("rO:");
    display.setCursor(70, 0);
    display.println(RawOrange, 1);
    display.setCursor(60, 10);
    display.println("rY:");
    display.setCursor(70, 10);
    display.println(RawYellow, 1);
    display.setCursor(60, 20);
    display.println("rV:");
    display.setCursor(70, 20);
    display.println(RawViolet, 1);
  }

  if (menu_number == 3 || menu_number == 6 ){  //pokaż grafy
      
    for (int i = 0; i < 5; i++) {
        maxValue = max(maxValue, ReadValues[i]); 
    }
    HeightRed     = int((CalcRed     / maxValue) * GraphHeight);
    HeightOrange  = int((CalcOrange  / maxValue) * GraphHeight);
    HeightYellow  = int((CalcYellow  / maxValue) * GraphHeight);
    HeightGreen   = int((CalcGreen   / maxValue) * GraphHeight);
    HeightBlue    = int((CalcBlue    / maxValue) * GraphHeight);
    HeightViolet  = int((CalcViolet  / maxValue) * GraphHeight);

    
    display.setCursor(1 * GrapWidth -10, 10);
    if (HeightRed >25){
        display.setTextColor(BLACK);
    }
       
    display.fillRect(0 * GrapWidth,     GraphHeight - HeightRed,    GrapWidth, HeightRed,     SSD1306_WHITE);
    display.fillRect(1 * GrapWidth + 1, GraphHeight - HeightOrange, GrapWidth, HeightOrange,  SSD1306_WHITE);
    display.fillRect(2 * GrapWidth + 2, GraphHeight - HeightYellow, GrapWidth, HeightYellow,  SSD1306_WHITE);
    display.fillRect(3 * GrapWidth + 3, GraphHeight - HeightGreen,  GrapWidth, HeightGreen,   SSD1306_WHITE);
    display.fillRect(4 * GrapWidth + 4, GraphHeight - HeightBlue,   GrapWidth, HeightBlue,    SSD1306_WHITE);
    display.fillRect(5 * GrapWidth + 5, GraphHeight - HeightViolet, GrapWidth, HeightViolet,  SSD1306_WHITE);
    display.setCursor(1 * GrapWidth -10, 0);
    if (HeightRed >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("R:");
    display.setCursor(2 * GrapWidth -10, 0);
    if (HeightOrange >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("O:");
    display.setCursor(3 * GrapWidth -10, 0);
    if (HeightYellow >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("Y:");
    display.setCursor(4 * GrapWidth -10, 0);
    if (HeightGreen >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("G:");
    display.setCursor(5 * GrapWidth -10, 0);
    if (HeightBlue >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("B:");
    display.setCursor(6 * GrapWidth -10, 0);
    if (HeightViolet >27){
        display.setTextColor(BLACK);
    }else {
        display.setTextColor(WHITE);
    }
    display.println("V:");

    maxValue = 0.0;
  }
  
    display.display();
    delay(750);
}
